



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>使用PushSharp给iOS应用推送消息</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">使用PushSharp给iOS应用推送消息</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-14 05:49:19 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>PushSharp是一个C#编写的服务端类库，用于推送消息到各种客户端，支持iOS(iPhone/iPad)、Android、Windows Phone、Windows 8、Amazo、Blackberry等设备。</p>
<p>官方网站：<a href="https://github.com/Redth/PushSharp" rel="external nofollow noreferrer">https://github.com/Redth/PushSharp</a></p>
<p>当前最新稳定版本为2.0.4，支持通过NuGet获取(<a href="https://www.nuget.org/packages/PushSharp/" rel="external nofollow noreferrer">https://www.nuget.org/packages/PushSharp/</a>)</p>
<p>&#160;</p>
<h2>主要特点</h2>
<p>提供了易于使用的API，支持以下平台的消息推送：</p>
<ul><li>Apple (APNS – iPhone, iPad, OSX 10.8+)：APNS即Apple Push Notification Service,详见:<a href="https://developer.apple.com/library/ios/documentation/NetworkingInternet/Conceptual/RemoteNotificationsPG/Chapters/ApplePushService.html" rel="external nofollow noreferrer">https://developer.apple.com/library/ios/documentation/NetworkingInternet/Conceptual/RemoteNotificationsPG/Chapters/ApplePushService.html</a></li>
<li>Android (GCM/C2DM - 手机及平板)：GCM即Google Cloud Message,详见:<a href="http://developer.android.com/google/gcm/index.html" rel="external nofollow noreferrer">http://developer.android.com/google/gcm/index.html</a></li>
<li>Chrome (GCM)</li>
<li>Amazon (ADM)：ADM即Amazon Device Messaging,详见:<a href="https://developer.amazon.com/sdk/adm/setup.html" rel="external nofollow noreferrer">https://developer.amazon.com/sdk/adm/setup.html</a></li>
<li>Windows Phone 7/7.5/8(包括FlipTile,CycleTile及IconicTile模板):详见:<a href="http://msdn.microsoft.com/en-us/library/windowsphone/develop/ff402558(v=vs.105).aspx" rel="external nofollow noreferrer">http://msdn.microsoft.com/en-us/library/windowsphone/develop/ff402558(v=vs.105).aspx</a></li>
<li>Windows 8</li>
<li>Blackberry (BIS and BES via PAP): 详见:<a href="http://docs.blackberry.com/en/developers/deliverables/51382/" rel="external nofollow noreferrer">http://docs.blackberry.com/en/developers/deliverables/51382/</a></li>
<li>Firefox OS (即将支持)</li></ul>
<p>100%的托管代码完全兼容Mono平台。</p>
<p>&#160;</p>
<h2>安装</h2>
<p>PushSharp主要包含以下程序集：</p>
<ul><li>PushSharp.Core：(必选)核心组件</li>
<li>PushSharp.Apple：APNS,用于iOS及OSX</li>
<li>PushSharp.Android：C2DM及GCM,用于Android设备</li>
<li>PushSharp.Windows：用于Windows 8</li>
<li>PushSharp.WindowsPhone：用于WP设备</li>
<li>PushSharp.Amazon.Adm：用于Amazon的设备</li>
<li>PushSharp.Blackberry：用于黑莓设备</li>
<li>PushSharp.Google.Chrome：用于Chrome</li></ul>
<p>其中，PushSharp.Core为必须的组件，其他的可以根据自己需要来选择对应平台。</p>
<p>平常使用只需要用NuGet来获取程序集即可：</p>
<pre class="prettyprint linenums">Install-Package PushSharp</pre>
<p>这样会把主流平台的程序集(Apple/Android/Windows/WindowsPhone)都下载下来，可以根据自己需要删除用不到的平台组件。</p>
<p>假如需要使用Blackberry等NuGet包里没有的组件，则需要到官方网站(<a href="https://github.com/Redth/PushSharp" rel="external nofollow noreferrer">https://github.com/Redth/PushSharp</a>)获取源码自行编译。</p>
<p>对于Apple平台，只需要PushSharp.Core和PushSharp.Apple组件即可。</p>
<p>&#160;</p>
<h2>证书配置</h2>
<p>官方WIKI提供了详细的证书配置步骤：</p>
<ul><li>Apple平台的证书配置：<a href="https://github.com/Redth/PushSharp/wiki/How-to-Configure-&amp;-Send-Apple-Push-Notifications-using-PushSharp" rel="external nofollow noreferrer">https://github.com/Redth/PushSharp/wiki/How-to-Configure-&amp;-Send-Apple-Push-Notifications-using-PushSharp</a></li>
<li>Android平台的证书配置(使用GCM情况下)：<a href="https://github.com/Redth/PushSharp/wiki/How-to-Configure-&amp;-Send-GCM-Google-Cloud-Messaging-Push-Notifications-using-PushSharp" rel="external nofollow noreferrer">https://github.com/Redth/PushSharp/wiki/How-to-Configure-&amp;-Send-GCM-Google-Cloud-Messaging-Push-Notifications-using-PushSharp</a></li></ul>
<p>&#160;</p>
<p>Apple平台证书创建流程：</p>
<ul><li>创建AppID</li>
<li>为AppID配置用于APP签名的证书：分别有开发环境(Development)和生产环境(Production)的证书</li>
<li>编辑AppID启用消息推送</li>
<li>为AppID创建用于消息推送(APNS)的证书(包括Development和Production)</li>
<li>下载以上证书并安装到Key Chain(钥匙串)</li>
<li>导出用于消息推送(APNS)的证书为.p12格式，并为它设置密码：用于在服务端推送消息</li></ul>
<p>&#160;</p>
<p>对于Apple平台需要特别说明：</p>
<ul><li>Provisioning Protal现在已经变成了<a href="https://developer.apple.com/account/overview.action" rel="external nofollow noreferrer">Certificates, Identifiers &amp; Profiles</a>，可以从<a href="https://developer.apple.com/account/overview.action" rel="external nofollow noreferrer">Member Center</a>点进去或者<a href="https://developer.apple.com/devcenter/ios/index.action" rel="external nofollow noreferrer">iOS Developer Center</a>找到</li>
<li>对于已经发布的APP要启用消息推送功能，需要在Identifiers – <a href="https://developer.apple.com/account/ios/identifiers/bundle/bundleList.action" rel="external nofollow noreferrer">App IDs</a>找到对应的ID创建好APNS证书之后，再重新生成用于APP签名的证书，否则用于注册消息推送的代码(RegisterForRemoteNotificationTypes)不会正常工作，即返回的deviceToken为null</li>
<li>在使用Development证书调试应用程序时服务端需要使用Development APNS证书来推送消息，使用Production证书发布到AppStore后推送消息需要使用Production APNS证书来推送消息</li></ul>
<p>&#160;</p>
<h2>客户端启用消息推送</h2>
<p>启用消息推送都是在AppDelegate里注册来完成的。</p>
<p>对于使用objc语言编写的客户端：</p>
<pre class="prettyprint linenums">- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions<br />
{<br />
    if (application.enabledRemoteNotificationTypes == UIRemoteNotificationTypeNone)<br />
    {<br />
        [application registerForRemoteNotificationTypes:<br />
         UIRemoteNotificationTypeAlert |<br />
         UIRemoteNotificationTypeBadge |<br />
         UIRemoteNotificationTypeSound];<br />
    }<br />
    application.applicationIconBadgeNumber = -1;<br />
    // Override point for customization after application launch.<br />
    return YES;<br />
}

- (void)application:(UIApplication *)application didRegisterForRemoteNotificationsWithDeviceToken:(NSData *)deviceToken<br />
{<br />
    NSString *pushToken = [[[[deviceToken description]<br />
                             stringByReplacingOccurrencesOfString:@&quot;&lt;&quot;withString:@&quot;&quot;]<br />
                            stringByReplacingOccurrencesOfString:@&quot;&gt;&quot; withString:@&quot;&quot;]<br />
                           stringByReplacingOccurrencesOfString: @&quot; &quot; withString: @&quot;&quot;];<br />
    [[NSUserDefaults standardUserDefaults] setObject:pushToken forKey:@&quot;pushtoken&quot;]; // 保存起来<br />
}</pre>
<p>对于使用MonoTouch的客户端：</p>
<pre class="prettyprint linenums">        public override bool FinishedLaunching(UIApplication app, NSDictionary options)<br />
        {<br />
            app.RegisterForRemoteNotificationTypes(<br />
                UIRemoteNotificationType.Alert |<br />
                UIRemoteNotificationType.Badge |<br />
                UIRemoteNotificationType.Sound);<br />
            app.ApplicationIconBadgeNumber = -1;<br />
            // ...<br />
            return true;<br />
        }

        public override void RegisteredForRemoteNotifications(UIApplication application, NSData deviceToken)<br />
        {<br />
            // 成功接收到用于消息推送的token<br />
            string tokenStr = token.Description;<br />
            string pushToken = tokenStr.Replace(&quot;&lt;&quot;, string.Empty).Replace(&quot;&gt;&quot;, string.Empty).Replace(&quot; &quot;, string.Empty);<br />
            NSUserDefaults.StandardUserDefaults.SetString(pushToken, &quot;pushtoken&quot;);<br />
        }

        public override void FailedToRegisterForRemoteNotifications(UIApplication application, NSError error)<br />
        {<br />
            // 消息推送注册失败<br />
        }

        public override void DidReceiveRemoteNotification(UIApplication application, NSDictionary userInfo, Action&lt;UIBackgroundFetchResult&gt; completionHandler)<br />
        {<br />
            // 接收到推送的消息<br />
            // 在iOS7可能需要开启Background Modes的Remote Notifications<br />
        }</pre>
<p>在接收到deviceToken的时候先存储在NSUserDefaults中，在用户登录的时候再取出来一起发送到服务端：</p>
<pre class="prettyprint linenums">NSString *pushToken = [[NSUserDefaults standardUserDefaults] stringForKey:@&quot;pushtoken&quot;]; //objc<br />
string pushToken = NSUserDefaults.StandardUserDefaults.StringForKey(&quot;pushtoken&quot;); //MonoTouch</pre>
<p>服务端在用户登录成功之后，把接收到用户的用户名与pushToken关联起来，在推送消息的时候就可以针对指定用户来推送，具体的过程略。</p>
<p>而对于不需要用户登录的app，可以在接收到deviceToken的时候直接发送到服务端。</p>
<p>更多的客户端配置参考PushSharp源码的<strong>Client.Samples</strong>及<strong>PushSharp.Client</strong>目录。</p>
<p>&#160;</p>
<h2>服务端推送消息</h2>
<pre class="prettyprint linenums">var pusher = new PushBroker();<br />
pusher.RegisterAppleService(new ApplePushChannelSettings(File.ReadAllBytes(&quot;yourAppId.p12&quot;), &quot;证书的密码&quot;));<br />
pusher.QueueNotification(<br />
                new AppleNotification()<br />
                    .ForDeviceToken(pushToken) // 从数据库等地方获取设备的pushToken<br />
                    .WithAlert(&quot;测试iOS消息推送 - 囧月&quot;)<br />
                    .WithBadge(1)<br />
                    .WithSound(&quot;default&quot;)<br />
            );</pre>
<p>在RegisterAppleService方法中可以注册多个APNS证书，PushSharp可以自动检测是Development/Production，这时候需要为证书设置标识：</p>
<pre class="prettyprint linenums">pusher.RegisterAppleService(new ApplePushChannelSettings(File.ReadAllBytes(&quot;yourAppId.p12&quot;), &quot;证书的密码&quot;), &quot;证书标识如youAppId_development&quot;);<br />
pusher.RegisterAppleService(new ApplePushChannelSettings(File.ReadAllBytes(&quot;yourAppId.p12&quot;), &quot;证书的密码&quot;), &quot;证书标识如youAppId_production&quot;);</pre>
<p>此外，可以注册各种事件来获得各种状态：</p>
<pre class="prettyprint linenums">pusher.OnDeviceSubscriptionChanged += pusher_OnDeviceSubscriptionChanged;<br />
pusher.OnDeviceSubscriptionExpired += pusher_OnDeviceSubscriptionExpired;<br />
pusher.OnNotificationSent += pusher_OnNotificationSent;<br />
pusher.OnNotificationFailed += pusher_OnNotificationFailed;<br />
pusher.OnNotificationRequeue += pusher_OnNotificationRequeue;<br />
pusher.OnChannelCreated += pusher_OnChannelCreated;<br />
pusher.OnChannelDestroyed += pusher_OnChannelDestroyed;<br />
pusher.OnChannelException += pusher_OnChannelException;<br />
pusher.OnServiceException += pusher_OnServiceException;

static void pusher_OnNotificationFailed(object sender, INotification notification, Exception error)<br />
{<br />
    var n = (AppleNotification)notification;<br />
    //error.Message ...获取推送出错的信息<br />
}

static void pusher_OnNotificationSent(object sender, INotification notification)<br />
{<br />
    //消息推送成功后<br />
    var n = (AppleNotification)notification;<br />
    //n.Payload.Alert.Body  获取推送的消息内容...<br />
}

static void pusher_OnDeviceSubscriptionExpired(object sender, string expiredSubscriptionId, DateTime expirationDateUtc, INotification notification)<br />
{<br />
    // 从数据库删除过期的expiredSubscriptionId<br />
}

static void pusher_OnDeviceSubscriptionChanged(object sender, string oldSubscriptionId, string newSubscriptionId, INotification notification)<br />
{<br />
    // 把数据库中的oldSubscriptionId更新为newSubscriptionId<br />
}</pre>
<p>更多请参考源码的<strong>PushSharp.Sample</strong>目录。</p>
<p>&#160;</p>
<h2>参考</h2>
<p>官方网站：<a href="https://github.com/Redth/PushSharp" rel="external nofollow noreferrer">https://github.com/Redth/PushSharp</a> 可以获取最新源码及各种例子</p>
<p>WIKI：<a href="https://github.com/Redth/PushSharp/wiki" rel="external nofollow noreferrer">https://github.com/Redth/PushSharp/wiki</a>&#160; 详细说明了各平台证书配置的方法</p>
<p>Xamarin相关文档：<a>http://docs.xamarin.com/guides/cross-platform/application_fundamentals/notifications/ios/remote_notifications_in_ios/</a>&#160;</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pem1z8.html">Entity Framework Code First （八）迁移 Migrations</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jkrvg8.html">罗辑思维CEO李天田：我们是这样玩儿公司的</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e10w2z9.html">UVA 1362 Exploring Pyramids  区间DP</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeor2z9.html">Jquery事件委托之Safari</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1wrej9.html">Spark SQL概念学习系列之Spark SQL 架构分析（四）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1lnrj8.html">Android Studio无法启动 打开， Android Studio gradle下载不了</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvn1jxq.html">SQL SERVER查看当前连接情况</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjookz9.html">codevs1226倒水问题（Bfs）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1p32x9.html">DLL注入&lowbar;拦截技术之Hook方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdjmjr8.html">SPOJ 220 Relevant Phrases of Annihilation（后缀数组&plus;二分答案）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1w02mq.html">查看一个int数组里边的每个数字出现过几次</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjwr5r8.html">&lbrack;IB配置&rsqb;PeopleSoft如何重置网关属性administrator密码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj413j8.html">intellij idea 插件开发--快速定位到mybatis mapper文件中的sql</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljxm3e9.html">The requested URL &sol; was not found on this server&mdash;&mdash;Apache配置虚拟域名后无法访问localhost</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j64gw8.html">Python，PyCharm2017安装教程，包含注册码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdplovxq.html">C&plus;&plus; 默认参数（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gew2d48.html">mix-blend-mode</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv140o1q.html">emacs Can&amp;&num;39&semi;t guess python-indent-offset&comma; using defaults&colon; 4</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z6vzj9.html">请不要在广州&period;NET俱乐部群里谈郑智话题，谢谢！</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj16r79.html">el-popover 的显示或隐藏，要在拿到真实dom之后再做控制</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/o5qy29rz.html">01&period;SQLServer性能优化之---水平分库扩展</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pj2d9x.html">菜鸟学Struts2&mdash;&mdash;Results</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gjj497.html">javascript中的继承与深度拷贝</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q257oq7.html">获取微软原版&OpenCurlyDoubleQuote;Windows 10 推送器（GWX）&rdquo; 卸载工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mjyo8k.html">MySQL 系列（四）主从复制、备份恢复方案生产环境实战</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jewl85.html">PHP设计模式（四）单例模式（Singleton For PHP）</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxoneqy.html">Extjs 让combobox写起来更简单</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1jd0qg.html">exp&sol;imp 与 expdp&sol;impdp 区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8ejym91.html">linux下配置matlab运行环境&lpar;MCR&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p31kqx.html">LeetCode All in One 题目讲解汇总&lpar;持续更新中&period;&period;&period;&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
